/*
FILE: DialogCtrl.c
NOTE: The State Machine Wizard will add mapping macros between /*{{ and /*}}. Do NOT modify manually.
*/

#include "sme_debug.h"
#include "Service.h"
#include "display.h"
#include "DialogCtrl.h"
#include "global.h"

SME_BEGIN_STATE_DEF(DialogCtrl,DialogCtrl)
	/*{{SME_STATE_DEF(DialogCtrl,DialogCtrl)*/
	SME_STATE_ENTRY_FUNC(DialogCtrlEntry)
	SME_STATE_EXIT_FUNC(DialogCtrlExit)
	SME_ON_EVENT(EVENT_DLG_YES,OnDialogCtrlEVENT_DLG_YES,SME_INTERNAL_TRAN)
	SME_ON_EVENT(EVENT_DLG_NO,OnDialogCtrlEVENT_DLG_NO,SME_INTERNAL_TRAN)
	SME_ON_EVENT(EVENT_KEY_LEFTSOFT,OnDialogCtrlEVENT_KEY_LEFTSOFT,SME_INTERNAL_TRAN)
	SME_ON_EVENT(EVENT_KEY_RIGHTSOFT,OnDialogCtrlEVENT_KEY_RIGHTSOFT,SME_INTERNAL_TRAN)
	SME_ON_EVENT(EVENT_OUT_OF_MEMORY,NULL,Abnormal)
	SME_ON_EVENT(EVENT_ON_CALLING,NULL,Calling)
	/*}}SME_STATE_DEF*/
SME_END_STATE_DEF

SME_BEGIN_STATE_DEF(DialogCtrl,Normal)
	/*{{SME_STATE_DEF(DialogCtrl,Normal)*/
	SME_STATE_ENTRY_FUNC(NormalEntry)
	SME_STATE_EXIT_FUNC(NormalExit)
	/*}}SME_STATE_DEF*/
SME_END_STATE_DEF

SME_BEGIN_STATE_DEF(DialogCtrl,Abnormal)
	/*{{SME_STATE_DEF(DialogCtrl,Abnormal)*/
	SME_STATE_ENTRY_FUNC(AbnormalEntry)
	SME_STATE_EXIT_FUNC(AbnormalExit)
	/*}}SME_STATE_DEF*/
SME_END_STATE_DEF

SME_BEGIN_STATE_DEF(DialogCtrl,Calling)
	/*{{SME_STATE_DEF(DialogCtrl,Calling)*/
	SME_STATE_ENTRY_FUNC(CallingEntry)
	SME_STATE_EXIT_FUNC(CallingExit)
	/*}}SME_STATE_DEF*/
SME_END_STATE_DEF

/*{{SME_STATE_STATETREE_SEPARATOR}}*/

SME_BEGIN_STATE_TREE_DEF(DialogCtrl)
	/*{{SME_STATE_TREE_DEF(DialogCtrl)*/
	SME_STATE(DialogCtrl,DialogCtrl,SME_INVALID_STATE,Normal)
	SME_STATE(DialogCtrl,Normal,0,-1)
	SME_STATE(DialogCtrl,Abnormal,0,-1)
	SME_STATE(DialogCtrl,Calling,0,-1)
	/*}}SME_STATE_TREE_DEF*/
SME_END_STATE_TREE_DEF

/*{{SME_DEC_IMP_SEPARATOR}}*/

SME_APPLICATION_DEF(DialogCtrl, "DialogCtrl")

void* pBlockForDialog=NULL;

int DialogCtrlEntry(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	if(SelMenu.menuId==ID_MENU_SMS_NEW)
		pBlockForDialog=SmeMAlloc(88);
	else
		pBlockForDialog=SmeMAlloc(48);
	return 0;
}

int DialogCtrlExit(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	SmeMFree(pBlockForDialog);
	return 0;
}

int NormalEntry(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	UICtrlSetSoftkey(&SoftKey,SID_DLG_SKL,EVENT_DLG_NO,SID_DLG_SKR,EVENT_DLG_YES);
	DialogUpdateDisplay(TRUE);
	return 0;
}

int NormalExit(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	return 0;
}

int AbnormalEntry(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	UICtrlSetSoftkey(&SoftKey,SID_WARN_SKL,EVENT_NULL,SID_WARN_SKR,EVENT_DLG_NO);
	DialogUpdateDisplay(FALSE);
	return 0;
}

int AbnormalExit(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	return 0;
}

int CallingEntry(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	ClearScreen();
	DrawTextStrAt(2,MODE_CENTER,GetTextStr(SID_ON_CALLING,default_lang),default_font,DISPLAY_DEFAULT_PEN_COLOR);
	UICtrlSetSoftkey(&SoftKey,SID_DLG_SKL,EVENT_DLG_NO,SID_DLG_SKR,EVENT_DLG_YES);
	DrawSoftkey(&SoftKey,default_lang,default_font,DISPLAY_DEFAULT_PEN_COLOR);
	SrvUpdateDisplay(0,0,96,64,Buf);
	return 0;
}


int CallingExit(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	return 0;
}

int OnDialogCtrlEVENT_KEY_LEFTSOFT(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	UICtrlLeftSoftKeyPress(&SoftKey);
	return 0;
}


int OnDialogCtrlEVENT_KEY_RIGHTSOFT(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	UICtrlRightSoftKeyPress(&SoftKey);
	return 0;
}

int OnDialogCtrlEVENT_DLG_YES (struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	SelFunc.funcStrId=SelMenu.menuId;
	switch(SelFunc.funcStrId){
	default:
		SelFunc.funcEventId=EVENT_FUNC_DISP;
		break;
	}
	SelFunc.isSelected=TRUE;
	UICtrlPostInternalEvent(EVENT_DLG_OK,pApp->pParent);
	return 0;
}

int OnDialogCtrlEVENT_DLG_NO (struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	UICtrlPostInternalEvent(EVENT_DLG_CANCEL,pApp->pParent);
	return 0;
}

int DialogUpdateDisplay(BOOL isNormal)
{
	const SME_CHAR *title,*str,*skl,*skr;
	title=GetTextStr(SID_TITLE,default_lang);
	skl=GetTextStr(SID_DLG_SKL,default_lang);
	skr=GetTextStr(SID_DLG_SKR,default_lang);
	if(isNormal)
		str=GetTextStr(SelMenu.menuId,default_lang);
	else
		str=GetTextStr(SID_WARNING,default_lang);
	SrvClearDisplay();
	ClearScreen();
	DrawTextStr(0,1,title,default_font,DISPLAY_DEFAULT_PEN_COLOR);
	DrawLine(0,15,95,15,DISPLAY_DEFAULT_PEN_COLOR);
	DrawTextStr(0,23,str,default_font,DISPLAY_DEFAULT_PEN_COLOR);
	DrawSoftkey(&SoftKey,default_lang,default_font,DISPLAY_DEFAULT_PEN_COLOR);
	SrvUpdateDisplay(0,0,96,64,Buf);
	return 0;
}





