// Service.c : Map the service function call to Windows messages.
//

#include "Service.h"
#include "SrvAgent.h"
#include "sme_debug.h"
#include "main.h"

void SrvPowerControl()
{
	AgtPostServiceCall(SRV_ID_POWER_CONTROL, NULL, 0);
	SME_ASCII_TRACE(MODULE_SRV_CALL_POWERUPDOWN, "SrvPowerControl");
}

void SrvClearDisplay()
{
	AgtPostServiceCall(SRV_ID_CLEAR_DISPLAY, NULL, 0);
	SME_ASCII_TRACE(MODULE_SRV_CALL_DISP,"SrvClearDisplay");
}

void SrvTurnOffDisplay()
{
	AgtPostServiceCall(SRV_ID_CLEAR_DISPLAY, NULL, 0);
	SME_ASCII_TRACE(MODULE_SRV_CALL_DISP,"SrvTurnOffDisplay");
}

void SrvUpdateDisplay(int nLeft, int nTop, int nWidth, int nHeight, unsigned char *pData)
{
	SRV_CALL_UPDATE_DISPLAY_T CallData;
	CallData.nLeft = nLeft;
	CallData.nTop = nTop;
	CallData.nWidth = nWidth;
	CallData.nHeight = nHeight;
	CallData.pData = pData;

	AgtPostServiceCall(SRV_ID_UPDATE_DISPLAY, &CallData, sizeof(CallData));
	SME_ASCII_TRACE(MODULE_SRV_CALL_DISP,"SrvUpdateDisplay");
}

void SrvRefreshDisplay(int nLeft, int nTop, int nWidth, int nHeight, unsigned char *pData)
{
	SRV_CALL_UPDATE_DISPLAY_T CallData;
	CallData.nLeft = nLeft;
	CallData.nTop = nTop;
	CallData.nWidth = nWidth;
	CallData.nHeight = nHeight;
	CallData.pData = pData;

	AgtPostServiceCall(SRV_ID_UPDATE_DISPLAY, &CallData, sizeof(CallData));
}

void SrvUpdateMemoryStatistic(unsigned int size){
	unsigned int CallData;
	CallData=size;
	AgtSendServiceCall(SRV_ID_MEMORY_STATISTIC, &CallData, sizeof(CallData));
	/*SME_ASCII_TRACE(MODULE_SRV_CALL_DISP,"SrvUpdateMemoryStatistic");*/
}

unsigned int SrvSetTimer(unsigned int nElapse,void* pDestPort)
{
	int nTimerID=0;
	SRV_SET_TIMER_T CallData;
	CallData.nElapse=nElapse;
	CallData.pDestPort=pDestPort;
	CallData.pTimerID = &nTimerID;
	AgtSendServiceCall(SRV_ID_SET_TIMER, &CallData, sizeof(CallData));
	SME_ASCII_TRACE(MODULE_SRV_CALL_CLK,"SrvSetTimer");
	return nTimerID;
}

BOOL SrvKillTimer(unsigned int nTimerID)
{
	SRV_KILL_TIMER_T CallData;
	CallData.nTimerID = nTimerID;
	AgtSendServiceCall(SRV_ID_KILL_TIMER, &CallData, sizeof(CallData));
	SME_ASCII_TRACE(MODULE_SRV_CALL_CLK,"SrvKillTimer");
	return TRUE;
}

void SrvGetTime(int *pHour, int *pMinute, int *pSecond)
{
	SRV_GET_TIME_T CallData;

	CallData.pHour = pHour;
	CallData.pMinute = pMinute;
	CallData.pSecond = pSecond;

	AgtSendServiceCall(SRV_ID_GET_TIME, &CallData, sizeof(CallData));
}

#define MAX_PORT_NUM 10

void** SrvGetPortInfoPtr()
{
	static SME_APP_T* PortArray[MAX_PORT_NUM]={NULL};
	static int nPortIdx=0;

	if (nPortIdx<MAX_PORT_NUM) 
	{
		nPortIdx++;
		return &(PortArray[nPortIdx]);
	} return NULL;
}

