/* UICtrl.h
*/

#ifndef UICTRL_H
#define UICTRL_H

#ifdef __cplusplus  /* Allow header file to be included in a C++ file */
extern "C" {
#endif

#include "service.h"
#include "sme_rc.h"

typedef struct SOFTKEY_INFO_T{
	unsigned long sklStrId;
	SME_EVENT_ID_T sklEventId;
	unsigned long skrStrId;
	SME_EVENT_ID_T skrEventId;
	BOOL isDefined;
}SOFTKEY_INFO_T;

typedef struct FUNCTION_INFO_T{
	unsigned long funcStrId;
	SME_EVENT_ID_T funcEventId;
	BOOL isSelected;
}FUNCTION_INFO_T;

typedef struct MENU_INFO_T{
	unsigned long menuId;
	BOOL isSelected;
}MENU_INFO_T;

////////////////////////////////////////////////////////////////
// UI controller function definitions.

void UICtrlPostInternalEvent(long event_id,SME_APP_T *pApp);
void UICtrlSetSoftkey(SOFTKEY_INFO_T* pSoftkey,
				   unsigned long sklStrId,SME_EVENT_ID_T sklEventId,
				   unsigned long skrStrId,SME_EVENT_ID_T skrEventId);
void UICtrlLeftSoftKeyPress(SOFTKEY_INFO_T* pSoftkey);
void UICtrlRightSoftKeyPress(SOFTKEY_INFO_T* pSoftkey);
void UICtrlOnRightSoftKey(SOFTKEY_INFO_T* pSoftkey,SME_APP_T *pParentApp);


#ifdef __cplusplus  /* Allow header file to be included in a C++ file */
}
#endif /* __cplusplus */

#endif  /* UICTRL_H  */
